> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/pt-br/web-scraper-api/alvos/e-commerce/lowes.md).

# Lowe's

Saiba como começar a fazer scraping do Lowe's.

Com o Web Scraper API, você pode raspar vários tipos de **Lowe's** páginas; abaixo está uma visão geral de todos os scrapers compatíveis e seus respectivos `source` valores. A resposta retorna o HTML da página em `content`, na estrutura padrão de resposta descrita em [Realtime](/products/pt-br/web-scraper-api/integration-methods/realtime.md) e [Push-Pull](/products/pt-br/web-scraper-api/integration-methods/push-pull.md).

{% hint style="warning" %}
Para alguns alvos, nosso sistema **força a renderização de JavaScript** mesmo se você não definir `render`; essas solicitações contam como tráfego renderizado. A lista de alvos com renderização forçada e como desativar a renderização estão em [Forçando a renderização em páginas específicas](/products/pt-br/web-scraper-api/features/js-rendering-and-browser-control.md#forcing-rendering-on-specific-pages).
{% endhint %}

<table><thead><tr><th width="250">Fonte</th><th>Descrição</th></tr></thead><tbody><tr><td><code>lowes_search</code></td><td><a href="#search"><strong>Página de busca</strong></a> para um termo de busca de sua escolha.</td></tr><tr><td><code>lowes_product</code></td><td><a href="#product"><strong>Página de produto</strong></a> de um ID de produto de sua escolha.</td></tr></tbody></table>

Qualquer outra página da Lowe's pode ser raspada informando sua `url` sozinha, sem `source` necessário.

{% hint style="info" %}
Além dos parâmetros listados abaixo, você pode incluir parâmetros adicionais, como `user_agent_type`, `geo_location`, `render`, e mais, para personalizar sua solicitação de scraping. Leia mais [aqui](/products/pt-br/web-scraper-api/features.md).
{% endhint %}

## Busca

### Exemplos de requisição

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "lowes_search",
        "query": "iphone"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Estruture o payload.
payload = {
    'source': 'lowes_search',
    'query': 'iphone'
}

# Obtenha a resposta.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Em vez de uma resposta com status do trabalho e URL de resultados, isto retornará a
# resposta JSON com o resultado.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "lowes_search",
    query: "iphone"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
A string inteira que você envia precisa estar codificada em URL.

https://realtime.oxylabs.io/v1/queries?source=lowes_search&query=iphone&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'lowes_search',
    'query' => 'iphone'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{} {
        "source": "lowes_search",
        "query": "iphone",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "lowes_search",
                query = "iphone"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "lowes_search");
        jsonObject.put("query", "iphone");

        Authenticator authenticator = (route, response) => {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "lowes_search",
    "query": "iphone"
}
```

{% endtab %}
{% endtabs %}

### Valores dos parâmetros da solicitação <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">Parâmetro</th><th>Descrição</th><th width="160">Valor padrão</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>Define o scraper.</td><td><code>lowes_search</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>query</code></strong></mark></td><td>A palavra-chave ou frase para pesquisar produtos.</td><td>-</td></tr><tr><td><code>store_id</code>, <code>delivery_zip</code>, <code>free_delivery</code>, <code>pickup_today</code>, <code>delivery_today_tomorrow</code></td><td>Filtros opcionais de localização e disponibilidade, veja <a href="#localization-and-filtering">Localização e filtragem</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- parâmetro obrigatório

## Produto <a href="#product" id="product"></a>

### Exemplos de requisição

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "lowes_product",
        "product_id": "5012490299"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Estruture o payload.
payload = {
    'source': 'lowes_product',
    'product_id': '5012490299'
}

# Obtenha a resposta.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Em vez de uma resposta com status do trabalho e URL de resultados, isto retornará a
# resposta JSON com o resultado.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "lowes_product",
    product_id: "5012490299"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
A string inteira que você envia precisa estar codificada em URL.

https://realtime.oxylabs.io/v1/queries?source=lowes_product&product_id=5012490299&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'lowes_product',
    'product_id' => '5012490299'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{} {
        "source": "lowes_product",
        "product_id": "5012490299",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "lowes_product",
                product_id = "5012490299"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "lowes_product");
        jsonObject.put("product_id", "5012490299");

        Authenticator authenticator = (route, response) => {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "lowes_product",
    "product_id": "5012490299"
}
```

{% endtab %}
{% endtabs %}

### Valores dos parâmetros da solicitação <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">Parâmetro</th><th>Descrição</th><th width="160">Valor padrão</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>Define o scraper.</td><td><code>lowes_product</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>product_id</code></strong></mark></td><td>O ID numérico do produto no final da URL da página do produto, por exemplo <code>lowes.com/pd/Apple-iPhone-13-Pro-Clear-Case-with-MagSafe/</code><strong><code>5012490299</code></strong>.</td><td>-</td></tr><tr><td><code>store_id</code>, <code>delivery_zip</code></td><td>Parâmetros opcionais de localização, veja <a href="#localization-and-filtering">Localização e filtragem</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- parâmetro obrigatório

## Localização e filtragem

<table><thead><tr><th width="150">Parâmetro</th><th width="170">Aplica-se a</th><th width="348">Descrição</th><th width="90">Padrão</th></tr></thead><tbody><tr><td><code>store_id</code></td><td><code>lowes_search</code>, <code>lowes_product</code></td><td>Número da loja Lowe's como um inteiro, por exemplo <code>2752</code>. Seleciona a loja cuja disponibilidade e preços a página mostra.</td><td>-</td></tr><tr><td><code>delivery_zip</code></td><td><code>lowes_search</code>, <code>lowes_product</code></td><td>CEP de entrega como uma string, por exemplo <code>"22313"</code>. Aplicado em conjunto com <code>store_id</code>.</td><td>-</td></tr><tr><td><code>free_delivery</code></td><td><code>lowes_search</code></td><td>Defina como <code>true</code> para mostrar apenas produtos com frete grátis.</td><td>-</td></tr><tr><td><code>pickup_today</code></td><td><code>lowes_search</code></td><td>Defina como <code>true</code> para mostrar apenas produtos disponíveis para retirada no mesmo dia.</td><td>-</td></tr><tr><td><code>delivery_today_tomorrow</code></td><td><code>lowes_search</code></td><td>Defina como <code>true</code> para mostrar apenas produtos que podem ser entregues no mesmo dia ou no dia seguinte.</td><td>-</td></tr></tbody></table>

Os três filtros aceitam `true` ou `false` apenas. Sem `store_id`, a página mostra uma loja escolhida pela própria Lowe's e `delivery_zip` não é aplicado.

```json
{
    "source": "lowes_search",
    "query": "iphone",
    "store_id": 2752,
    "delivery_zip": "22313",
    "free_delivery": true
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.oxylabs.io/products/pt-br/web-scraper-api/alvos/e-commerce/lowes.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
